<!DOCTYPE html>
<html>
  <head>
    <link rel="stylesheet" type="text/css" href="https://pyscript.net/alpha/pyscript.css"/>
    <link rel="stylesheet" type="text/css" href="static/style.css"/>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>DRB Python Training</title>
    <script defer src="https://pyscript.net/alpha/pyscript.js"></script>
    <script src="static/check.js"></script>

    <title>
        <b>DRB Python Training</b>
    </title>
</head>


  <body class="my_body">
    <h1 class="big_title">Xquery</h1>
    <br/>
    <h2 class="chapter">What is Xquery ?</h2>
    <br/>
    <p>XQuery is a computer query language allowing not only to extract information from an XML document, or from a collection of XML documents, but also to perform complex calculations from the extracted information and to reconstruct new documents or XML snippets.</p>
    <br/>
    <h2 class="chapter">Xquery and Drb</h2>
    <br/>
    <p>
      Implementation of XQuery request for DRB (Data Request Broker) Nodes This implementation is dedicated to DRB Nodes and not support all standard of <a href="https://gitlab.com/drb-python/xquery">Xquery</a>.
    </p>
    <br/>
    <br/>

    <h2 class="chapter">Xquery Syntax:</h2>
    <br/>
    <p>
      XQuery elements, attributes, and variables must be valid XML names and follow case sensitivity.<br/>
      XQuery Syntax Rules:</p>
      <ul>
        <li>XQuery follows case-sensitivity.</li>
        <li>XQuery elements, attributes, and variables must be valid XML names.</li>
        <li>An XQuery string value can be in single or double quotes.</li>
        <li>An XQuery variable is defined with a $ followed by a name, for example:. $XFDU</li>
        <li>XQuery comments are delimited by (: and :), e.g. (: XQuery Comment :)</li>
      </ul>
      <br/>
      <p>
      The "If-Then-Else" conditional statement is allowed in XQuery.
    </p>
      <pre>
        <code class="language-yml"> 
            if (matches(name(), "S2A.*"))
            then "A"
            else
              if (matches(name(), "S2B.*"))
              then "B"
              else "UNKNOWN"
          </code>
      </pre>
    <br>
    <h2 class="chapter">Examples :</h2>
    <br/>
    <p> 
      Here an example on how to use a Xquery on a Xml node, to request a certain node.<br/>
      The result is always a list of value or dynamic context.
    </p>
    <pre>
      <code class="language-py"> 
          node = DrbFactoryResolver().create("/path_xml_file/namefile.xml")

          # request node named 2A_Tile_ID with ns as namespace
          query = DrbXQuery("/ns:Level-2A_Tile_ID")
          result = query.execute(node)        
        </code>
    </pre>
    <br/>

    <p> 
      You can also call a Xquery with external variable.
    </p>
    <pre>
      <code class="language-py"> 
          # create the query from  String   
          query = DrbXQuery("declare variable $x external; "
                            "declare variable $y external := 5; $x+$y")

          result = query.execute(None, x=9, y=12)

          # result[0] == 21               
        </code>
    </pre>
    <br/>

    <p> 
      Here an example of getting a certain value of a manifest file of a S2 product without Xquery
    </p>
    <pre>
      <code class="language-py"> 
          uri_tar = '/path/to/your/S2_file.tar'
          resolver = DrbFactoryResolver()
          node = resolver.create(uri_tar)
          node['manifest.safe']['XFDU']['dataObjectSection']['...']['checksum'].value
      </code>
    </pre>
    <br/>
    <p> 
      Here the same example with Xquery
    </p>
    <pre>
      <code class="language-py"> 
          xquery_request = "declare namespace xfdu='urn:ccsds:schema:xfdu:1';\n" \
          "let $checksum := fn:doc('" + uri_tar + "')" \
              "/manifest.safe/xfdu:XFDU/dataObjectSection/dataObject[@ID='IMG_DATA_Band_20m_3_Band']/byteStream/checksum\n" \
          "return fn:data($checksum)"

          query_local = DrbXQuery(xquery_request).execute(None)
          # result[0] == '3c0c936e19e0dbcfa2efebb8c3665c65'               
      </code>
    </pre>

    <br/>

    <h2 class="chapter">Limitations and differences with W3C standard</h2>
    <br/>
    <p>
      The data() function return only the value of elt<br/>
      for example :
    </p>
    <pre>
      <code class="language-py"> 
          data(element root {element foo {"child"}, " parent" })
</code>
</pre>
<p>
return in W3C standard:
</p>
<pre>
  <code class="language-py"> 
          child parent
</code>
</pre>
<p>
return in this implementation:
</p>
<pre>
  <code class="language-py"> 
          parent
</code>
</pre>
<p>
The infinity value is allowed for Decimal as for float: In W3C infinity is
only allowed for float or double.<br/>
The type xs:double is identical to xs:float The type xs:long, xs:short, xs:byte are identical to xs:integer<br/>
Other limitations<br/>
Some types are not defined like: xs:anyURI xs:untypedAtomic...<br/>
Some functions are not yet implemented like: yearMonthDuration deep-equal remove processing-instruction exactly-one...<br/>
Some expressions are not (yet) implemented like: group by order by typeswitch treat as map and array are not defined too
    </p>
    <br/>
    <br/>
    <footer>
      <p><a href="/">Home Page</a></p>
    </footer>
    <footer id="err-div" class="bg-red-700 text-white text-center border-t-4 border-green-500 fixed inset-x-0 bottom-0 p-4 hidden"/>
    
    

    
  </body>
</html>
